package apicrypt

import (
	"PaymentCenter/app/constants/pojo"
	"PaymentCenter/app/models/appmodel"
)

type (
	ApiCrypt interface {
		Encrypt(decryptData string) (encryptData []byte, errCode int)
		Decrypt(encryptData string) (decryptData []byte, errCode int)
	}

	Rsa struct {
		App *appmodel.App
	}

	SM2 struct {
		App *appmodel.App
	}

	SM4 struct {
		App *appmodel.App
	}
)

var ApiCryptMap = map[int32]func(app *appmodel.App) ApiCrypt{
	pojo.RSA: NewRsa,
	pojo.SM2: NewSm2,
	pojo.SM4: NewSm4,
}
